## opentoonz-dmo 1.6.0

=== .github/workflows/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(mypaint LANGUAGES C)

find_package(json-c CONFIG REQUIRED)

include_directories(${JSON-C_INCLUDE_DIR})

set(sources
  brushmodes.c
  fifo.c
  helpers.c
  mypaint-brush-settings.c
  mypaint-brush.c
  mypaint-fixed-tiled-surface.c
  mypaint-mapping.c
  mypaint-matrix.c
  mypaint-rectangle.c
  mypaint-surface.c
  mypaint-symmetry.c
  mypaint-tiled-surface.c
  mypaint.c
  operationqueue.c
  rng-double.c
  tilemap.c
  utils.c
)
set(headers
  mypaint-config.h
  mypaint-glib-compat.h
  mypaint-mapping.h
  mypaint-matrix.h
  mypaint-symmetry.h
  config.h
  mypaint.h
)

add_library(libmypaint STATIC ${sources} ${headers})

=== toonz/sources/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

set(CMAKE_BUILD_TYPE_INIT Release)

project(OpenToonz)


#-----------------------------------------------------------------------------
# Platform Specific Defaults

# list of var-names
set(_init_vars)

#-----------------------------------------------------------------------------
# Select build target
set(BUILD_TARGET_WIN       OFF)
set(BUILD_TARGET_APPLE     OFF)
set(BUILD_TARGET_UNIX      OFF)
if(WIN32)
    set(BUILD_TARGET_WIN    ON)
    message(STATUS "Target system is WIN")
elseif(APPLE)
    set(BUILD_TARGET_APPLE  ON)
    message(STATUS "Target system is APPLE")
elseif(UNIX)
    set(BUILD_TARGET_UNIX   ON)
    message(STATUS "Target system is UNIX")
else()
    set(BUILD_TARGET_UNIX   ON)
    message(WARNING "Target system unknown, set UNIX by default")
    message(STATUS "Target system is UNIX (actually unknown)")
endif()

#-----------------------------------------------------------------------------
# Select build environment

set(BUILD_ENV_MSVC     OFF)
set(BUILD_ENV_APPLE    OFF)
set(BUILD_ENV_UNIXLIKE OFF)
if(MSVC)
    set(BUILD_ENV_MSVC ON)
    if(NOT BUILD_TARGET_WIN)
        message(WARNING "Build environment is MSVC, but target system is not WIN")
    endif()
    message(STATUS "Build environment is MSVC")
elseif(CMAKE_HOST_APPLE)
    set(BUILD_ENV_APPLE ON)
    if(NOT BUILD_TARGET_APPLE)
        message(WARNING "Build environment is APPLE, but target system is not APPLE")
    endif()
    message(STATUS "Build environment is APPLE")
elseif(CMAKE_HOST_UNIX OR CMAKE_COMPILER_IS_GNUCC)
    set(BUILD_ENV_UNIXLIKE ON)
    if(NOT BUILD_TARGET_UNIX AND NOT BUILD_TARGET_WIN)
        message(WARNING "Build environment is UNIXLIKE, but target system is not UNIX or WIN")
    endif()
    message(STATUS "Build environment is UNIXLIKE")
else()
    message(ERROR "Unsupported build environment, only MSVC, APPLE and UNIXLIKE are supported")
endif()


# initialize to ON
macro(option_defaults_init)
    foreach(_var ${ARGV})
        set(${_var} ON)
        list(APPEND _init_vars "${_var}")
    endforeach()
    unset(_var)
endmacro()

# remove from namespace
macro(option_defaults_clear)
    foreach(_var ${_init_vars})
        unset(${_var})
    endforeach()
    unset(_var)
    unset(_init_vars)
endmacro()

# values to initialize WITH_****
option_defaults_init(
    _init_SYSTEM_LZO
)

# customize...
if(BUILD_ENV_MSVC)
    set(_init_SYSTEM_LZO                     OFF)
    set(_init_SYSTEM_SUPERLU                 OFF)
elseif(BUILD_ENV_APPLE)
    set(_init_SYSTEM_LZO                     OFF)
    set(_init_SYSTEM_SUPERLU                 OFF)
elseif(BUILD_ENV_UNIXLIKE)
    set(_init_SYSTEM_LZO                     ON)
    set(_init_SYSTEM_SUPERLU                 ON)
endif()


#-----------------------------------------------------------------------------
# Build Options

option(WITH_SYSTEM_LZO "Use the system LZO library instead of 'thirdpary'" ${_init_SYSTEM_LZO})
option(WITH_SYSTEM_SUPERLU "Use the system SuperLU library instead of 'thirdpary'" ${_init_SYSTEM_SUPERLU})
option(WITH_CANON "Build with Canon DSLR support - Requires Canon SDK" OFF)
option(WITH_TRANSLATION "Generate translation projects as well" ON)
option(WITH_WINTAB "(Windows only) Build with customized Qt with WinTab support. https://github.com/shun-iwasawa/qt5/releases/tag/v5.15.2_wintab" OFF)

# avoid using again
option_defaults_clear()

# end option(...)

#-----------------------------------------------------------------------------
# Platform Architecture

if(BUILD_ENV_APPLE)
    if(NOT PLATFORM)
        set(PLATFORM 64)
    endif()
else() # Windows and Linux case
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(PLATFORM 64)
        set(PLATFORM2 _64)
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(PLATFORM 32)
        set(PLATFORM2)
    else()
        message("Warning : CMAKE_SIZEOF_VOID_P = ${CMAKE_SIZEOF_VOID_P}")
        set(PLATFORM 64)
        set(PLATFORM2 _64)
    endif()
endif()
message("PLATFORM:" ${PLATFORM})

#-----------------------------------------------------------------------------
# Third Party & System Libs

include(${CMAKE_SOURCE_DIR}/../cmake/util_compiler.cmake)

get_filename_component(SDKROOT ../../thirdparty/ ABSOLUTE)
message(STATUS "SDK Root:" ${SDKROOT})
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/../cmake")
if(BUILD_ENV_APPLE)
    set(THIRDPARTY_LIBS_HINTS "/usr/local/Cellar/" "/opt/include" ${SDKROOT})
elseif(BUILD_ENV_MSVC OR BUILD_ENV_UNIXLIKE)
    set(THIRDPARTY_LIBS_HINTS ${SDKROOT})
endif()

message(STATUS "Thirdpary Library Search path:" ${THIRDPARTY_LIBS_HINTS})

if(BUILD_ENV_MSVC)
    set(QT_PATH "C:/Qt/5.15.2/msvc2019${PLATFORM2}" CACHE PATH "Qt installation directory")
    if(NOT EXISTS ${QT_PATH})
        message("Specify QT_PATH properly")
        return()
    endif()
    set(QT_LIB_PATH ${QT_PATH})
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${QT_PATH}/lib/cmake/")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4251")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251")
    add_definitions(
        -DVC_EXTRALEAN
        -DNOMINMAX
        -D_USE_MATH_DEFINES
    )
elseif(BUILD_ENV_APPLE)
    set(QT_PATH "~/Qt5.9.2/5.9.2/clang_${PLATFORM}/lib" CACHE PATH "Qt installation directory")
    set(QT_LIB_PATH "${QT_PATH}/")
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${QT_LIB_PATH}cmake/")
    foreach(path ${CMAKE_PREFIX_PATH})
      message("CMAKE_PREFIX_PATH: " ${path})
    endforeach(path)
    add_definitions(
        -DMACOSX
        -Di386
        -D__MACOS__
    )
    if(PLATFORM EQUAL 64)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -std=c++11 -stdlib=libc++ -fno-implicit-templates")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m64")
    elseif(PLATFORM EQUAL 32)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32 -std=c++11 -stdlib=libc++ -fno-implicit-templates -D HAS_QUICKDRAW")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
        set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -m32")
    else()
        message(FATAL_ERROR "Invalid PLATFORM:" ${PLATFORM} ". 'PLATFORM' must be 32 or 64.")
    endif()
elseif(BUILD_ENV_UNIXLIKE)
    # Needed for correct Qt detection
    cmake_minimum_required(VERSION 2.8.12)
    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
        add_definitions(-DLINUX)
    elseif(CMAKE_SYSTEM_NAME MATCHES "^.*BSD$|DragonFly")
        set(BUILD_TARGET_BSD ON)
        add_definitions(-D_BSD_SOURCE -DFREEBSD)
        include_directories("/usr/local/include/")
        message(STATUS "Configuring for BSD system")
    elseif(NOT BUILD_TARGET_WIN)
        message(WARNING "Support for generic Unix (Not Apple or Linux) isn't yet working!")
    endif()

    set(CMAKE_CXX_STANDARD 11)

    find_package(Qt5Widgets)

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    if (NOT (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -lstdc++")
    endif()
endif()

add_definitions(
    -DQT_GUI_LIB
    -DQT_NETWORK_LIB
    -DQT_CORE_LIB
    -DQT_SHARED
)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(BUILD_ENV_APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH ${QT_LIB_PATH})
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    set(CMAKE_FIND_FRAMEWORK LAST)
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${QT_LIB_PATH}" isSystemDir)
    if("${isSystemDir}" STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${QT_LIB_PATH}")
    endif()
endif()

include_directories(
    include
)

# Find the QtWidgets library
find_package(Qt5 REQUIRED
    Core
    Gui
    Network
    OpenGL
    Svg
    Xml
    Script
    Widgets
    PrintSupport
    LinguistTools
    Multimedia
    MultimediaWidgets
    SerialPort
)

set(QT_MINIMUM_VERSION 5.5.0)
if(Qt5Core_VERSION VERSION_LESS QT_MINIMUM_VERSION)
    MESSAGE(FATAL_ERROR "Minimum supported Qt version: ${QT_MINIMUM_VERSION}.
    Installed version: ${Qt5Core_VERSION}")
endif()
unset(QT_MINIMUM_VERSION)

if(BUILD_ENV_MSVC)
    include_directories(
        SYSTEM
        ${SDKROOT}/glut/3.7.6/include
        ${SDKROOT}/zlib-1.2.8
        #${SDKROOT}/LibJPEG/jpeg-9
        ${SDKROOT}/libjpeg-turbo/include
    )
    add_definitions(
        -DGLUT_NO_LIB_PRAGMA
    )
endif()


if(PLATFORM EQUAL 64)
    if(BUILD_ENV_UNIXLIKE)
        find_package(OpenCV REQUIRED)
    else() # Windows and MacOS case
        find_package(OpenCV 4.1 REQUIRED)
    endif()
    #include_directories(
    #    ${SDKROOT}/libjpeg-turbo64/include
    #)
    if(WITH_CANON)
        include_directories(
            ${SDKROOT}/canon/Header
        )
    endif()
endif()

get_target_property(QtCore_location Qt5::Core LOCATION)
get_target_property(QtWidget_location Qt5::Widgets LOCATION)
message(STATUS "Qt Core Location:" ${QtCore_location})

macro(_find_toonz_library OUT_LIB_LIST IN_LIB_LIST)
    set(OUTLIST "")
    foreach(arg ${IN_LIB_LIST})
        unset(COREPATH CACHE)
        # find しても cmake が走るときにはできていないので完全なパス名を生成して返すだけ
        if(BUILD_ENV_APPLE)
            set(LIBPATH "\$<TARGET_FILE:${arg}>")
        else()
            set(LIBPATH ${arg})
        endif()
        set(OUTLIST ${OUTLIST} ${LIBPATH})
    endforeach()
    set(${OUT_LIB_LIST} ${OUTLIST})
endmacro()

set(TNZSTDFX_Location)
set(TFARM_Location)

set(QT_LIB)  # avoid warning

if(BUILD_ENV_MSVC)
    set(MSVC_LIB_VERSION 2015)

    set(GLUT_LIB ${SDKROOT}/glut/3.7.6/lib/glut${PLATFORM}.lib)
    set(GL_LIB opengl32.lib)
    set(Z_LIB
        optimized ${SDKROOT}/zlib-1.2.8/lib/zlib-1.2.8_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug ${SDKROOT}/zlib-1.2.8/lib/zlib-1.2.8_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    #set(JPEG_LIB ${SDKROOT}/LibJPEG/jpeg-9/lib/LibJPEG-9_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(JPEG_LIB ${SDKROOT}/libjpeg-turbo/lib/jpeg-static_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(TURBOJPEG_LIB ${SDKROOT}/libjpeg-turbo/lib/turbojpeg-static_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(TIFF_INCLUDE_DIR ${SDKROOT}/tiff-4.0.3/libtiff)
    set(TIFF_LIB
        optimized ${SDKROOT}/tiff-4.0.3/lib/LibTIFF-4.0.3_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug  ${SDKROOT}/tiff-4.0.3/lib/LibTIFF-4.0.3_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    set(PNG_LIB
        optimized ${SDKROOT}/libpng-1.6.21/lib/libpng16_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug  ${SDKROOT}/libpng-1.6.21/lib/libpng16_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    set(GLEW_LIB ${SDKROOT}/glew/glew-1.9.0/lib/glew${PLATFORM}.lib)
    set(LZ4_LIB ${SDKROOT}/Lz4/Lz4_131/lz4_${PLATFORM}.lib)
    set(SUPERLU_LIB ${SDKROOT}/superlu/SuperLU_${MSVC_LIB_VERSION}_${PLATFORM}.lib)
    set(OPENBLAS_LIB ${SDKROOT}/openblas/libopenblas_${PLATFORM}.lib)
    set(USB_LIB)  # unused
    
    if(PLATFORM EQUAL 32)
        set(QT_LIB ${SDKROOT}/quicktime/QT73SDK/Libraries/QTMLClient.lib)
    endif()
    set(MYPAINT_LIB_INCLUDE_DIRS ${SDKROOT}/libmypaint/dist/${PLATFORM}/include/libmypaint)
    set(MYPAINT_LIB_LDFLAGS ${SDKROOT}/libmypaint/dist/${PLATFORM}/libmypaint.lib)

    if(PLATFORM EQUAL 64)
        if (WITH_CANON)
            set(CANON_LIB ${SDKROOT}/canon/library/EDSDK.lib)
        endif()
    endif()
elseif(BUILD_ENV_APPLE)
    find_library(GLUT_LIB GLUT)
    find_library(GL_LIB OpenGL)
    find_library(Z_LIB z)

    find_package(TIFF REQUIRED)
    set(TIFF_LIB ${TIFF_LIBRARY})
    # the libraries have not .pc nor preferred Find*.cmake. use custom modules.
    find_package(PNG REQUIRED)
    message("******* libpng:" ${PNG_LIBRARY})
    set(PNG_LIB ${PNG_LIBRARY})
    find_package(GLEW)

    find_package(SuperLU REQUIRED)
    set(SUPERLU_INCLUDE_DIR ${SUPERLU_INCLUDE_DIR}/superlu)
    set(SUPERLU_LIB ${SUPERLU_LIBRARY})
    message("SuperLU:" ${SUPERLU_INCLUDE_DIR})

    find_package(JPEG REQUIRED)

    # the libraries have .pc
    find_package(PkgConfig)
    if(GLEW-NOTFOUND)
        pkg_check_modules(GLEW REQUIRED glew)
    endif()
    if (TARGET GLEW::GLEW)

=== toonz/sources/colorfx/CMakeLists.txt ===
set(HEADERS
    ../include/colorfx.h
    colorfxutils.h
    rasterstyles.h
    regionstyles.h
    strokestyles.h
    zigzagstyles.h
)

set(SOURCES
    colorfx.cpp
    colorfxutils.cpp
    rasterstyles.cpp
    regionstyles.cpp
    strokestyles.cpp
    zigzagstyles.cpp
)

if(WITH_TRANSLATION)
    add_translation(colorfx ${HEADERS} ${SOURCES})
endif()

add_library(colorfx SHARED ${HEADERS} ${SOURCES})
add_definitions(
    -D_USRDLL
    -DCOLORFX_EXPORTS
    -DUSE_MESA
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libcolorfx.dylib")
    add_dependencies(colorfx tnzcore tnzbase)
endif()

message("subdir: colorfx")
message("type:" ${CMAKE_SHARED_LIBRARY_SUFFIX})
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

_find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase")

message("FIND_FILE:" ${EXTRA_LIBS})

target_link_libraries(colorfx Qt5::Core ${GL_LIB} ${EXTRA_LIBS})

=== toonz/sources/image/CMakeLists.txt ===
set(HEADERS
    sgi/tiio_sgi.h
    pli/pli_io.h
    pli/tiio_pli.h
    tga/tiio_tga.h
    compatibility/inforegion.h
    compatibility/tfile_io.h
    compatibility/tnz4.h
    quantel/filequantel.h
    quantel/filequantelP.h
    quantel/tiio_quantel.h
    png/tiio_png.h
    psd/tiio_psd.h
    svg/tiio_svg.h
    tzl/tiio_tzl.h
    ../include/tnzimage.h
    mov/tiio_mov_proxy.h
    3gp/tiio_3gp_proxy.h
    ffmpeg/tiio_gif.h
    ffmpeg/tiio_webm.h
    ffmpeg/tiio_mp4.h
    ffmpeg/tiio_ffmpeg.h
    sprite/tiio_sprite.h
    mesh/tiio_mesh.h
    exr/tinyexr_otmod.h
    exr/tiio_exr.h
)

set(SOURCES
    tiio.cpp
    sgi/filesgi.cpp
    pli/pli_io.cpp
    pli/tags.cpp
    pli/tiio_pli.cpp
    tga/tiio_tga.cpp
    compatibility/inforegion.c
    compatibility/tfile_io.c
    compatibility/tnz4.c
    compatibility/tnz4_cpp.cpp
    quantel/filequantel.c
    quantel/tiio_quantel.cpp
    png/tiio_png.cpp
    psd/tiio_psd.cpp
    svg/tiio_svg.cpp
    tzl/tiio_tzl.cpp
    mov/tiio_mov_proxy.cpp
    3gp/tiio_3gp_proxy.cpp
    ffmpeg/tiio_gif.cpp
    ffmpeg/tiio_webm.cpp
    ffmpeg/tiio_mp4.cpp
    ffmpeg/tiio_ffmpeg.cpp
    sprite/tiio_sprite.cpp
    mesh/tiio_mesh.cpp
    exr/tiio_exr.cpp
)


# Can't build this on FreeBSD: libtiff requires internal API access.
# Probably some one get luck to fix this.
if(NOT BUILD_TARGET_BSD)
    set(HEADERS ${HEADERS}
        tif/tiio_tif.h
        tzp/tiio_plt.h
        tzp/tiio_tzp.h
        tzp/toonztags.h
    )
    set(SOURCES ${SOURCES}
        tif/tiio_tif.cpp
        tzp/tiio_plt.cpp
        tzp/tiio_tzp.cpp
        tzp/avl.c
    )
endif()


if(BUILD_TARGET_WIN)
    set(HEADERS ${HEADERS}
        avi/tiio_avi.h
        mov/tiio_mov.h
        3gp/tiio_3gp.h
    )
    set(SOURCES ${SOURCES}
        avi/tiio_avi.cpp
        mov/tiio_movW.cpp
        3gp/tiio_3gpW.cpp
    )
elseif(BUILD_TARGET_APPLE)
    set(HEADERS ${HEADERS}
        mov/tiio_movM.h
        3gp/tiio_3gpM.h
    )
    set(SOURCES ${SOURCES}
        mov/tiio_movM.cpp
        3gp/tiio_3gpM.cpp
    )
elseif(BUILD_TARGET_UNIX)
    set(HEADERS ${HEADERS}
        3gp/tiio_3gp_proxy.h
        mov/tiio_mov_proxy.h
    )
    set(SOURCES ${SOURCES}
        mov/tiio_mov_proxy.cpp
        3gp/tiio_3gp_proxy.cpp
    )
endif()

if(WITH_TRANSLATION)
    add_translation(image ${HEADERS} ${SOURCES})
endif()

add_library(image SHARED ${HEADERS} ${SOURCES})
add_definitions(
    -DTNZIMAGE_DLL
    -D_USRDLL
    -DIMAGE_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libimage.dylib")
    add_dependencies(image tnzcore tnzbase toonzlib)
endif()

message("subdir: image")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

include_directories(
    SYSTEM
    ${TIFF_INCLUDE_DIR}
)

if(NOT BUILD_TARGET_BSD)
    include_directories(
        ${SDKROOT}/LibJPEG/jpeg-9
    )
endif()


if(BUILD_ENV_MSVC)
    include_directories(
        SYSTEM
        ${SDKROOT}/libpng-1.6.21
    )
endif()
if(BUILD_TARGET_WIN AND PLATFORM EQUAL 32)
    include_directories(
        SYSTEM
        ${SDKROOT}/quicktime/QT73SDK/CIncludes
    )
endif()

include_directories(
    ${SDKROOT}/tinyexr
)


_find_toonz_library(TNZLIBS "tnzcore;tnzbase;toonzlib")


if(BUILD_ENV_MSVC)
    set(EXTRA_LIBS
        ${TNZLIBS}
        vfw32.lib
    )
elseif(BUILD_ENV_APPLE)
    if(PLATFORM EQUAL 32)
        find_library(CORE_SERVICES_LIB CoreServices)
        set(OSX_10_6_SDK_PATH "")
        if(NOT OSX_10_6_SDK_PATH)
            message(FATAL_ERROR "Set variable 'OSX_10_6_SDK_PATH'")
        endif()
        find_library(QD_LIB
            NAMES QD
            PATHS OSX10_6_SDK_PATH
        )
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -F ${OSX_10_6_SDK_PATH}")
    endif()
    set(EXTRA_LIBS
        ${TNZLIBS}
        ${QT_LIB}
        ${CARBON_LIB}
        ${CORE_SERVICES_LIB}
        ${QD_LIB}
    )
elseif(BUILD_ENV_UNIXLIKE)
    # Generic Unix
    set(EXTRA_LIBS
        ${TNZLIBS}
    )

    if(BUILD_TARGET_WIN)
        set(EXTRA_LIBS ${EXTRA_LIBS} -lvfw32)
    endif()
endif()

target_link_libraries(image Qt5::Core Qt5::Gui Qt5::Network ${Z_LIB} ${GLUT_LIB} ${GL_LIB} ${JPEG_LIB} ${TIFF_LIB} ${PNG_LIB} ${EXTRA_LIBS})

=== toonz/sources/sound/CMakeLists.txt ===
set(HEADERS
    wav/tsio_wav.h
    aiff/tsio_aiff.h
    raw/tsio_raw.h
    mp3/tsio_mp3.h
    ../include/tnzsound.h
    tsio.h
)

set(SOURCES
    tsio.cpp
    tsioutils.cpp
    wav/tsio_wav.cpp
    aiff/tsio_aiff.cpp
    raw/tsio_raw.cpp
    mp3/tsio_mp3.cpp
)

add_library(sound SHARED ${HEADERS} ${SOURCES})
add_definitions(
    -DSOUND_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libsound.dylib")
    add_dependencies(sound tnzcore tnzbase toonzlib)
endif()

message("subdir: sound")
message("type:" ${CMAKE_SHARED_LIBRARY_SUFFIX})
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

_find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase;toonzlib")
message("ToonzCore: " ${EXTRA_LIBS})

target_link_libraries(sound Qt5::Core ${EXTRA_LIBS})

=== toonz/sources/stdfx/CMakeLists.txt ===
set(HEADERS
    ../include/stdfx/shaderfx.h
    ../include/stdfx/shaderinterface.h
    ../include/stdfx/shadingcontext.h
    gradients.h
    hsvutil.h
    offscreengl.h
    particles.h
    particlesengine.h
    particlesfx.h
    particlesmanager.h
    perlinnoise.h
    pins.h
    stdfx.h
    texturefxP.h
    warp.h
    motionawarebasefx.h
    igs_color_blend.h
    igs_color_rgb_hls.h
    igs_color_rgb_hsv.h
    igs_density.h
    igs_fog.h
    igs_gaussian_blur.h
    igs_hls_add.h
    igs_hls_adjust.h
    igs_hls_noise.h
    igs_hls_noise_in_camera.h
    igs_hsv_add.h
    igs_hsv_adjust.h
    igs_hsv_noise.h
    igs_hsv_noise_in_camera.h
    igs_ifx_common.h
    igs_level_auto.h
    igs_level_auto_in_camera.h
    igs_levels.h
    igs_line_blur.h
    igs_math_random.h
    igs_maxmin.h
    igs_maxmin_getput.h
    igs_maxmin_lens_matrix.h
    igs_maxmin_multithread.h
    igs_maxmin_slrender.h
    igs_median_filter.h
    igs_median_filter_smooth.h
    igs_motion_blur.h
    igs_motion_wind.h
    igs_motion_wind_pixel.h
    igs_motion_wind_table.h
    igs_negate.h
    igs_os_type.h
    igs_perlin_noise.h
    igs_radial_blur.h
    igs_resource_msg_from_err.h
    igs_resource_multithread.h
    igs_resource_sleep.h
    igs_resource_thread.h
    igs_rotate_blur.h
    igs_warp.h
    ino_common.h
    iwa_adjustexposurefx.h
    iwa_directionalblurfx.h
    iwa_gradientwarpfx.h
    iwa_motionblurfx.h
    iwa_particles.h
    iwa_particlesengine.h
    iwa_particlesfx.h
    iwa_particlesmanager.h
    iwa_perspectivedistortfx.h
    iwa_spectrumfx.h
    iwa_simplexnoise.h
    iwa_noise1234.h
    iwa_fresnel.h
    iwa_pnperspectivefx.h
    iwa_soapbubblefx.h
    iwa_bokehfx.h
    iwa_timecodefx.h
    iwa_bokehreffx.h
    iwa_textfx.h
    iwa_corridorgradientfx.h
    iwa_spingradientfx.h
    iwa_lineargradientfx.h
    iwa_glarefx.h
    iwa_fractalnoisefx.h
    iwa_rainbow_intensity.h
    iwa_rainbowfx.h
    iwa_bokeh_advancedfx.h
    iwa_bokeh_util.h
    globalcontrollablefx.h
)

if(OpenCV_FOUND)
    list(APPEND HEADERS iwa_bloomfx.h)
endif()

set(SOURCES
    adjustlevelsfx.cpp
    artcontourfx.cpp
    backlitfx.cpp
    blendtzfx.cpp
    blurfx.cpp
    bodyhighlightfx.cpp
    bright_contfx.cpp
    calligraphicfx.cpp
    changecolorfx.cpp
    channelmixerfx.cpp
    cloudsfx.cpp
    colorembossfx.cpp
    cornerpinfx.cpp
    despecklefx.cpp
    diamondgradientfx.cpp
    dissolvefx.cpp
    embossfx.cpp
    erodilatefx.cpp
    externalpalettefx.cpp
    fourpointsgradientfx.cpp
    freedistortfx.cpp
    gammafx.cpp
    glowfx.cpp
    gradients.cpp
    hsvkeyfx.cpp
    hsvscalefx.cpp
    hsvutil.cpp
    kaleido.cpp
    linearwavefx.cpp
    localblurfx.cpp
    localtransparencyfx.cpp
    mosaicfx.cpp
    motionblurfx.cpp
    multitonefx.cpp
    noisefx.cpp
    nothingfx.cpp
    palettefilterfx.cpp
    particles.cpp
    particlesengine.cpp
    particlesfx.cpp
    particlesmanager.cpp
    perlinnoise.cpp
    perlinnoisefx.cpp
    pins.cpp
    posterizefx.cpp
    premultiplyfx.cpp
    radialblurfx.cpp
    randomwavefx.cpp
    raylitfx.cpp
    rgbkeyfx.cpp
    rgbmcutfx.cpp
    rgbmfadefx.cpp
    rgbmscalefx.cpp
    ripplefx.cpp
    rotationalblurfx.cpp
    saltpeppernoisefx.cpp
    shaderfx.cpp
    shaderinterface.cpp
    shadingcontext.cpp
    sharpenfx.cpp
    solarizefx.cpp
    squaregradientfx.cpp
    stdfx.cpp
    targetspotfx.cpp
    texturefx.cpp
    tilefx.cpp
    tonecurvefx.cpp
    unmultiplyfx.cpp
    warp.cpp
    warpfx.cpp
    igs_attenuation_distribution.cpp
    igs_color_blend.cpp
    igs_color_rgb_hls.cpp
    igs_color_rgb_hsv.cpp
    igs_density.cpp
    igs_fog.cpp
    igs_gauss_distribution.cpp
    igs_gaussian_blur.cpp
    igs_hls_add.cpp
    igs_hls_adjust.cpp
    igs_hls_noise.cpp
    igs_hls_noise_in_camera.cpp
    igs_hsv_add.cpp
    igs_hsv_adjust.cpp
    igs_hsv_noise.cpp
    igs_hsv_noise_in_camera.cpp
    igs_level_auto.cpp
    igs_level_auto_in_camera.cpp
    igs_levels.cpp
    igs_line_blur.cpp
    igs_math_random.cpp
    igs_maxmin.cpp
    igs_maxmin_lens_matrix.cpp
    igs_maxmin_slrender.cpp
    igs_median_filter.cpp
    igs_median_filter_smooth.cpp
    igs_motion_blur.cpp
    igs_motion_wind.cpp
    igs_motion_wind_pixel.cpp
    igs_motion_wind_table.cpp
    igs_negate.cpp
    igs_perlin_noise.cpp
    igs_radial_blur.cpp
    igs_resource_msg_from_err.cpp
    igs_resource_multithread.cpp
    igs_resource_sleep.cpp
    igs_resource_thread.cpp
    igs_rotate_blur.cpp
    igs_warp_hori.cpp
    igs_warp_vert.cpp
    ino_blend_add.cpp
    ino_blend_color_burn.cpp
    ino_blend_color_dodge.cpp
    ino_blend_cross_dissolve.cpp
    ino_blend_darken.cpp
    ino_blend_darker_color.cpp
    ino_blend_divide.cpp
    ino_blend_hard_light.cpp
    ino_blend_hard_mix.cpp
    ino_blend_lighten.cpp
    ino_blend_lighter_color.cpp
    ino_blend_linear_burn.cpp
    ino_blend_linear_dodge.cpp
    ino_blend_linear_light.cpp
    ino_blend_multiply.cpp
    ino_blend_over.cpp
    ino_blend_overlay.cpp
    ino_blend_pin_light.cpp
    ino_blend_screen.cpp
    ino_blend_soft_light.cpp
    ino_blend_subtract.cpp
    ino_blend_vivid_light.cpp
    ino_blur.cpp
    ino_channel_selector.cpp
    ino_common.cpp
    ino_density.cpp
    ino_fog.cpp
    ino_hls_add.cpp
    ino_hls_adjust.cpp
    ino_hls_noise.cpp
    ino_hsv_add.cpp
    ino_hsv_adjust.cpp
    ino_hsv_noise.cpp
    ino_level_auto.cpp
    ino_level_master.cpp
    ino_level_rgba.cpp
    ino_line_blur.cpp
    ino_maxmin.cpp
    ino_median.cpp
    ino_median_filter.cpp
    ino_motion_blur.cpp
    ino_motion_wind.cpp
    ino_negate.cpp
    ino_pn_clouds.cpp
    ino_radial_blur.cpp
    ino_spin_blur.cpp
    ino_warp_hv.cpp
    iwa_adjustexposurefx.cpp
    iwa_directionalblurfx.cpp
    iwa_gradientwarpfx.cpp
    iwa_motionblurfx.cpp
    iwa_particles.cpp
    iwa_particlesengine.cpp
    iwa_particlesfx.cpp
    iwa_particlesmanager.cpp
    iwa_perspectivedistortfx.cpp
    iwa_spectrumfx.cpp
    iwa_tilefx.cpp
    iwa_simplexnoise.cpp
    iwa_noise1234.cpp
    iwa_pnperspectivefx.cpp
    iwa_soapbubblefx.cpp
    ${SDKROOT}/kiss_fft130/kiss_fft.c
    ${SDKROOT}/kiss_fft130/tools/kiss_fftnd.c
    iwa_bokehfx.cpp
    iwa_timecodefx.cpp
    iwa_bokehreffx.cpp
    iwa_barreldistortfx.cpp
    iwa_textfx.cpp
    iwa_corridorgradientfx.cpp
    iwa_spingradientfx.cpp
    iwa_lineargradientfx.cpp
    iwa_glarefx.cpp
    iwa_fractalnoisefx.cpp
    iwa_rainbowfx.cpp
    iwa_bokeh_advancedfx.cpp
    iwa_bokeh_util.cpp
)

if(OpenCV_FOUND)
    list(APPEND SOURCES iwa_bloomfx.cpp)
endif()

set(OBJCSOURCES
)

add_library(tnzstdfx SHARED ${HEADERS} ${SOURCES} ${OBJCSOURCES})
add_definitions(
    -D_USRDLL
    -DTNZSTDFX_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libtnzstdfx.dylib")
    add_dependencies(tnzstdfx tnzcore tnzbase toonzlib)
endif()

message("subdir: tnzstdfx")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

if(GLEW_FOUND)
    include_directories(
        SYSTEM
        ${GLEW_INCLUDE_DIRS}
    )
else()
    include_directories(
        SYSTEM
        ${SDKROOT}/glew/glew-1.9.0/include
    )
endif()

include_directories(
    ${SDKROOT}/kiss_fft130
)

_find_toonz_library(TNZLIBS "tnzcore;tnzbase;toonzlib")

target_link_libraries(tnzstdfx Qt5::Core Qt5::Gui Qt5::OpenGL ${GL_LIB} ${GLEW_LIB} ${TNZLIBS} ${PTHREAD_LIBRARY})

if(OpenCV_FOUND)
    target_link_libraries(tnzstdfx ${OpenCV_LIBS})
endif()

=== toonz/sources/tnztools/CMakeLists.txt ===
set(MOC_HEADERS
    controlpointselection.h
    edittoolgadgets.h
    filltool.h
    fullcolorbrushtool.h
    fullcolorfilltool.h
    plastictool.h
    skeletonsubtools.h
    tooloptionscontrols.h
    toonzrasterbrushtool.h
    viewtools.h
    controlpointeditortool.h
    ../include/tools/imagegrouping.h
    ../include/tools/screenpicker.h
    ../include/tools/toolhandle.h
    ../include/tools/tooloptions.h
)

set(HEADERS
    ${MOC_HEADERS}
    autofill.h
    bluredbrush.h
    hookselection.h
    mypainttoonzbrush.h
    rasterselectiontool.h
    rgbpickertool.h
    rulertool.h
    selectiontool.h
    setsaveboxtool.h
    shifttracetool.h
    stylepickertool.h
    toonzvectorbrushtool.h
    vectorselectiontool.h
    ../include/tools/RGBpicker.h
    ../include/tools/cursormanager.h
    ../include/tools/cursors.h
    ../include/tools/levelselection.h
    ../include/tools/rasterselection.h
    ../include/tools/strokeselection.h
    ../include/tools/stylepicker.h
    ../include/tools/tool.h
    ../include/tools/toolcommandids.h
    ../include/tools/toolutils.h
)

set(SOURCES
    autofillpli.cpp
    autofilltlv.cpp
    cursormanager.cpp
    stylepicker.cpp
    tool.cpp
    toolhandle.cpp
    toolutils.cpp
    bendertool.cpp
    bluredbrush.cpp
    controlpointeditortool.cpp
    cuttertool.cpp
    edittool.cpp
    edittoolgadgets.cpp
    filltool.cpp
    fullcolorbrushtool.cpp
    fullcolorerasertool.cpp
    fullcolorfilltool.cpp
    geometrictool.cpp
    hooktool.cpp
    hookselection.cpp
    imagegrouping.cpp
    irontool.cpp
    levelselection.cpp
    magnettool.cpp
    morphtool.cpp
    paintbrushtool.cpp
    pinchtool.cpp
    plastictool.cpp
    plastictool_animate.cpp
    plastictool_build.cpp
    plastictool_meshedit.cpp
    plastictool_rigidity.cpp
    pumptool.cpp
    rastererasertool.cpp
    rastertapetool.cpp
    rasterselectiontool.cpp
    rgbpickertool.cpp
    selectiontool.cpp
    setsaveboxtool.cpp
    skeletonsubtools.cpp
    skeletontool.cpp
    stylepickertool.cpp
    trackertool.cpp
    typetool.cpp
    tooloptionscontrols.cpp
    tooloptions.cpp
    vectorerasertool.cpp
    vectorselectiontool.cpp
    vectortapetool.cpp
    viewtools.cpp
    controlpointselection.cpp
    rasterselection.cpp
    strokeselection.cpp
    screenpicker.cpp
    fingertool.cpp
    rulertool.cpp
    mypainttoonzbrush.cpp
    shifttracetool.cpp
    toonzrasterbrushtool.cpp
	toonzvectorbrushtool.cpp
)

set(RESOURCES tnztools.qrc)

qt5_add_resources(SOURCES ${RESOURCES})

if(WITH_TRANSLATION)
    add_translation(tnztools ${HEADERS} ${SOURCES})
endif()

qt5_wrap_cpp(SOURCES ${MOC_HEADERS})

add_library(tnztools SHARED ${HEADERS} ${SOURCES} ${RESOURCES})
add_definitions(
    -DTNZTOOLS_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libtnztools.dylib")
    add_dependencies(tnztools tnzcore tnzbase tnzext toonzlib toonzqt)
endif()

message("subdir: tnztools")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

include_directories(
    SYSTEM
    ${SDKROOT}/superlu/SupperLU_4.1/SRC
)
include_directories(
    ../include/tools
)

_find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase;tnzext;toonzlib;toonzqt")

target_link_libraries(tnztools Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Network Qt5::OpenGL ${GLUT_LIB} ${EXTRA_LIBS} ${GL_LIB} ${MYPAINT_LIB_LDFLAGS})

=== toonz/sources/toonz/CMakeLists.txt ===
set(VERSION 1.6)

set(MOC_HEADERS
    addfilmstripframespopup.h
    adjustlevelspopup.h
    adjustthicknesspopup.h
    antialiaspopup.h
    audiorecordingpopup.h
    autoinputcellnumberpopup.h
    batches.h
    batchserversviewer.h
    binarizepopup.h
    boardsettingspopup.h
    brightnessandcontrastpopup.h
    cachefxcommand.h
    camerasettingspopup.h
    canvassizepopup.h
    castviewer.h
    cleanuppaletteviewer.h
    cleanuppopup.h
    cleanuppreview.h
    cleanupsettingsmodel.h
    cleanupsettingspane.h
    cleanupsettingspopup.h
    cleanupswatch.h
    colormodelbehaviorpopup.h
    colormodelviewer.h
    comboviewerpane.h
    commandbar.h
    commandbarpopup.h
    convertpopup.h
    duplicatepopup.h
    dvdirtreeview.h
    dvitemview.h
    dvwidgets.h
    exportlevelpopup.h
    exportpanel.h
    exportscenepopup.h
    filebrowser.h
    filebrowsermodel.h
    filebrowserpopup.h
    fileinfopopup.h
    filmstrip.h
    flipbook.h
    formatsettingspopups.h
    frameheadgadget.h
    fxparameditorpopup.h
    histogrampopup.h
    historypane.h
    imageviewer.h
    insertfxpopup.h
    layerfooterpanel.h
    layerheaderpanel.h
    levelcreatepopup.h
    levelsettingspopup.h
    linesfadepopup.h
    lipsyncpopup.h
    autolipsyncpopup.h
    loadfolderpopup.h
    locatorpopup.h
    magpiefileimportpopup.h
    mainwindow.h
    matchline.h
    menubar.h
    menubarpopup.h
    meshifypopup.h
    messagepanel.h
    onionskinmaskgui.h
    outputsettingspopup.h
    overwritepopup.h
    pane.h
    pltgizmopopup.h
    preferencespopup.h
    previewer.h
    previewfxmanager.h
    projectpopup.h
    psdsettingspopup.h
    reframepopup.h
    renumberpopup.h
    reslist.h
    ruler.h
    savepresetpopup.h
    scanpopup.h
    scenesettingspopup.h
    sceneviewer.h
    sceneviewercontextmenu.h
    scriptconsolepanel.h
    separatecolorspopup.h
    separatecolorsswatch.h
    shortcutpopup.h
    soundtrackexport.h
    startuppopup.h
    styleshortcutswitchablepanel.h
    svncleanupdialog.h
    svncommitdialog.h
    svndeletedialog.h
    svnlockdialog.h
    svnlockframerangedialog.h
    svnpurgedialog.h
    svnrevertdialog.h
    svnupdateandlockdialog.h
    svnupdatedialog.h
    tapp.h
    tasksviewer.h
    testpanel.h
    timestretchpopup.h
    toolbar.h
    tpanels.h
    trackerpopup.h
	vectorguideddrawingpane.h
    vectorizerpopup.h
    vectorizerswatch.h
    versioncontrol.h
    versioncontroltimeline.h
    versioncontrolwidget.h
    viewerpane.h
    xshcellviewer.h
    xshcolumnviewer.h
    xsheetviewer.h
    xshnoteviewer.h
    xshrowviewer.h
    xshtoolbar.h
	xdtsimportpopup.h
	expressionreferencemanager.h
    tooloptionsshortcutinvoker.h
    exportxsheetpdf.h
)

if(PLATFORM EQUAL 64)
    set(MOC_HEADERS
        ${MOC_HEADERS}
        ../stopmotion/stopmotion.h
        ../stopmotion/stopmotioncontroller.h
        ../stopmotion/webcam.h
        ../stopmotion/jpgconverter.h
        ../stopmotion/canon.h
        ../stopmotion/stopmotionserial.h
        ../stopmotion/stopmotionlight.h
        cameracapturelevelcontrol.h
        penciltestpopup.h
    )
else()
    set(MOC_HEADERS
        ${MOC_HEADERS}
        cameracapturelevelcontrol_qt.h
        penciltestpopup_qt.h
    )
endif()

set(HEADERS
    ${MOC_HEADERS}
    celldata.h
    cellkeyframedata.h
    cellkeyframeselection.h
    cellselection.h
    columncommand.h
    columnselection.h
    curveio.h
    drawingdata.h
    exportlevelcommand.h
    filedata.h
    fileselection.h
    filmstripcommand.h
    filmstripselection.h
    floatingpanelcommand.h
    history.h
    iocommand.h
    keyframedata.h
    keyframemover.h
    keyframeselection.h
    kis_tablet_support_win8.h
    menubarcommandids.h
    moviegenerator.h
    scanlist.h
    sceneviewerevents.h
    selectionutils.h
    subcameramanager.h
    subscenecommand.h
    tfarmstuff.h
    versioncontrolgui.h
    versioncontrolxmlreader.h
    viewerdraw.h
    viewerpopup.h
    xshcellmover.h
    xsheetdragtool.h
    castselection.h
    ../include/cellposition.h
    ../include/orientation.h
    ../include/saveloadqsettings.h
    xdtsio.h
    levelcommand.h
# Tracker file
    ObjectTracker.h
    dummyprocessor.h
    metnum.h
    processor.h
    predict3d.h
    tvpjson_io.h
)

set(SOURCES
    floatingpanelcommand.cpp
    canvassizepopup.cpp
    commandbar.cpp
    commandbarpopup.cpp
    history.cpp
    loadfoldercommand.cpp
    loadfolderpopup.cpp
    main.cpp
    mainwindow.cpp
    matchline.cpp
    menubar.cpp
    menubarpopup.cpp
    mergecolumns.cpp
    moviegenerator.cpp
    pane.cpp
    previewer.cpp
    previewfxmanager.cpp
    ruler.cpp
    scanlist.cpp
    tapp.cpp
    toolbar.cpp
    batchserversviewer.cpp
    castviewer.cpp
    exportlevelpopup.cpp
    exportscenepopup.cpp
    colormodelviewer.cpp
    exportpanel.cpp
    filebrowser.cpp
    filebrowserversioncontrol.cpp
    filmstrip.cpp
    matchlinecommand.cpp
    messagepanel.cpp
    tasksviewer.cpp
    testpanel.cpp
    tpanels.cpp
    xshcellmover.cpp
    xshcellviewer.cpp
    xshcolumnviewer.cpp
    xsheetdragtool.cpp
    xsheetviewer.cpp
    xshnoteviewer.cpp
    xshrowviewer.cpp
    xshtoolbar.cpp
    sceneviewer.cpp
    sceneviewerevents.cpp
    viewerdraw.cpp
    viewerpane.cpp
    castselection.cpp
    cellselection.cpp
    columnselection.cpp
    fileselection.cpp
    filmstripselection.cpp
    keyframeselection.cpp
    addfilmstripframespopup.cpp
    camerasettingspopup.cpp
    convertpopup.cpp
    duplicatepopup.cpp
    dvdirtreeview.cpp
    filebrowserpopup.cpp
    formatsettingspopups.cpp
    fxparameditorpopup.cpp
    histogrampopup.cpp
    insertfxpopup.cpp
    layerfooterpanel.cpp
    layerheaderpanel.cpp
    levelcreatepopup.cpp
    levelsettingspopup.cpp
    lipsyncpopup.cpp
    autolipsyncpopup.cpp
    magpiefileimportpopup.cpp
    outputsettingspopup.cpp
    overwritepopup.cpp
    pltgizmopopup.cpp
    preferencespopup.cpp
    projectpopup.cpp
    psdsettingspopup.cpp
    renumberpopup.cpp
    runscriptcommand.cpp
    savepresetpopup.cpp
    scanpopup.cpp
    sceneviewercontextmenu.cpp
    scenesettingspopup.cpp
    scriptconsolepanel.cpp
    shortcutpopup.cpp
    soundtrackexport.cpp
    startuppopup.cpp
    subcameramanager.cpp
    kis_tablet_support_win8.cpp
    timestretchpopup.cpp
    trackerpopup.cpp
    vectorguideddrawingpane.cpp
    vectorizerpopup.cpp
    vectorizerswatch.cpp
    versioncontrol.cpp
    versioncontroltimeline.cpp
    versioncontrolxmlreader.cpp
    versioncontrolwidget.cpp
    viewerpopup.cpp
    cellselectioncommand.cpp
    columncommand.cpp
    filmstripcommand.cpp
    iocommand.cpp
    levelcommand.cpp
    print.cpp
    subscenecommand.cpp
    svncleanupdialog.cpp
    svncommitdialog.cpp
    svndeletedialog.cpp
    svnlockdialog.cpp
    svnlockframerangedialog.cpp
    svnrevertdialog.cpp
    svnupdateandlockdialog.cpp
    svnupdatedialog.cpp
    svnpurgedialog.cpp
    vcrcommand.cpp
    xsheetcmd.cpp
    celldata.cpp
    drawingdata.cpp
    filedata.cpp
    imageviewer.cpp
    keyframedata.cpp
    dvitemview.cpp
    dvwidgets.cpp
    flipbook.cpp
    frameheadgadget.cpp
    onionskinmaskgui.cpp
    batches.cpp
    tfarmstuff.cpp
    cleanuppaletteviewer.cpp
    cleanuppopup.cpp
    cleanuppreview.cpp
    cleanupsettingsmodel.cpp
    cleanupsettingspopup.cpp
    cleanupswatch.cpp
    cellkeyframedata.cpp
    cellkeyframeselection.cpp
    keyframemover.cpp
    cachefxcommand.cpp
    exportlevelcommand.cpp
    adjustlevelspopup.cpp
    adjustthicknesspopup.cpp
    binarizepopup.cpp
    brightnessandcontrastpopup.cpp
    linesfadepopup.cpp
    rendercommand.cpp
    curveio.cpp
    meshifypopup.cpp
    selectionutils.cpp
    antialiaspopup.cpp
    mergecmapped.cpp
    comboviewerpane.cpp
    historypane.cpp
    cleanupsettingspane.cpp
    audiorecordingpopup.cpp
    locatorpopup.cpp
    styleshortcutswitchablepanel.cpp
	reframepopup.cpp
	autoinputcellnumberpopup.cpp
	colormodelbehaviorpopup.cpp
	boardsettingspopup.cpp
	separatecolorsswatch.cpp
	separatecolorspopup.cpp
    xdtsio.cpp
	xdtsimportpopup.cpp
	expressionreferencemanager.cpp
    tooloptionsshortcutinvoker.cpp
    tvpjson_io.cpp
    exportxsheetpdf.cpp
# Tracker file
    dummyprocessor.cpp
    metnum.cpp
    ObjectTracker.cpp
    predict3d.cpp
)

if(PLATFORM EQUAL 64)
    set(SOURCES
        ${SOURCES}
        ../stopmotion/stopmotion.cpp
        ../stopmotion/stopmotioncontroller.cpp
        ../stopmotion/webcam.cpp
        ../stopmotion/jpgconverter.cpp
        ../stopmotion/canon.cpp
        ../stopmotion/stopmotionserial.cpp
        ../stopmotion/stopmotionlight.cpp
        cameracapturelevelcontrol.cpp
        penciltestpopup.cpp
    )
else()
    set(SOURCES
        ${SOURCES}
        cameracapturelevelcontrol_qt.cpp
        penciltestpopup_qt.cpp
    )
endif()

if(WITH_TRANSLATION)
    add_translation(toonz ${HEADERS} ${SOURCES})
endif()

set(OBJCSOURCES filebrowsermodel.cpp)

# Resource file(s)
set(RESOURCES toonz.qrc)

if(BUILD_ENV_MSVC)
    set(RC_FILE toonz.rc)
endif()

qt5_add_resources(SOURCES ${RESOURCES})

if(BUILD_ENV_APPLE)
    #set_source_files_properties(${OBJCSOURCES} PROPERTIES LANGUAGE OBJCXX)
    set_source_files_properties(${OBJCSOURCES} PROPERTIES COMPILE_FLAGS "-x objective-c++")
endif()

qt5_wrap_cpp(SOURCES ${MOC_HEADERS})

if(BUILD_ENV_MSVC)
    add_executable(OpenToonz WIN32 ${HEADERS} ${SOURCES} ${OBJCSOURCES} ${RESOURCES} ${RC_FILE})
else()
    set(MACOSX_BUNDLE_ICON_FILE "OpenToonz.icns")
    set_source_files_properties(OpenToonz.icns PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
    add_executable(OpenToonz MACOSX_BUNDLE OpenToonz.icns ${HEADERS} ${SOURCES} ${OBJCSOURCES} ${RESOURCES})
    #add_definitions(
    #    -DTNZBASE_EXPORTS
    #    -DTPARAM_EXPORTS
    #    -DTXSHEET_EXPORTS
    #    -DTFX_EXPORTS
    #    -DTAPPTOOLS_EXPORTS
    #    -DTTEST_EXPORTS
    #)
endif()

if(BUILD_TARGET_WIN)
    add_definitions(
        -DUNICODE
        -D_UNICODE
    )
endif()

message("subdir: toonz")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})
#message("Lib: " ${LIBRARY_OUTPUT_PATH})
#message("Exe: " ${EXECUTABLE_OUTPUT_PATH})
#message("Sources:" ${SOURCES})

include_directories(
    ../../sources/toonzfarm/include
    ../../sources/toonzqt
    ../../sources/stopmotion
)

if (WITH_CANON)
    add_definitions(-DWITH_CANON)
endif()

if (WITH_WINTAB AND BUILD_TARGET_WIN AND (PLATFORM EQUAL 64))
    add_definitions(-DWITH_WINTAB)
endif()

if(BUILD_ENV_APPLE)
    include_directories(../../sources/mousedragfilter)
    if(PLATFORM EQUAL 64)
        include_directories(${TURBOJPEG_INCLUDE_DIRS})
    endif()
endif()

if(BUILD_TARGET_WIN)
    if(PLATFORM EQUAL 32)
        include_directories(
            SYSTEM
            ${SDKROOT}/quicktime/QT73SDK/CIncludes
        )
    endif()
endif()

if(BUILD_ENV_MSVC)
    set(EXTRA_LIBS)
    if(PLATFORM EQUAL 64)
        set(EXTRA_LIBS ${EXTRA_LIBS} Qt5::SerialPort ${TURBOJPEG_LIB} ${OpenCV_LIBS})
        if(WITH_CANON)
            set(EXTRA_LIBS ${EXTRA_LIBS} ${CANON_LIB})
        endif()
    endif()
    target_link_libraries(OpenToonz
        Qt5::WinMain Qt5::Core Qt5::Gui Qt5::Network Qt5::OpenGL Qt5::Svg Qt5::Xml
        Qt5::Script Qt5::Widgets Qt5::PrintSupport Qt5::Multimedia
        ${GL_LIB} ${GLUT_LIB} 
        ${EXTRA_LIBS} strmiids
        tnzcore tnzbase toonzlib colorfx tnzext image sound toonzqt tnztools tnzstdfx tfarm
    )
elseif(BUILD_ENV_APPLE)
    find_library(COCOA_LIB Cocoa)

    _find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase;toonzlib;colorfx;tnzext;image;sound;toonzqt;tnztools")

    # 変なところにライブラリ生成するカスども
    set(EXTRA_LIBS ${EXTRA_LIBS} "$<TARGET_FILE:tnzstdfx>" "$<TARGET_FILE:tfarm>")
    set(X64ONLY_LIBS)
    if(PLATFORM EQUAL 64)
        set(X64ONLY_LIBS ${X64ONLY_LIBS} Qt5::SerialPort ${TURBOJPEG_LIB} ${OpenCV_LIBS})
        if(WITH_CANON)
            set(X64ONLY_LIBS ${X64ONLY_LIBS} ${CANON_LIB})
        endif()
    endif()

=== toonz/sources/toonzlib/CMakeLists.txt ===
set(MOC_HEADERS
    ../include/toonz/fullcolorpalette.h
    ../include/toonz/movierenderer.h
    ../include/toonz/multimediarenderer.h
    ../include/toonz/palettecontroller.h
    ../include/toonz/preferences.h
    ../include/toonz/scriptbinding.h
    ../include/toonz/scriptbinding_centerline_vectorizer.h
    ../include/toonz/scriptbinding_files.h
    ../include/toonz/scriptbinding_image.h
    ../include/toonz/scriptbinding_image_builder.h
    ../include/toonz/scriptbinding_level.h
    ../include/toonz/scriptbinding_outline_vectorizer.h
    ../include/toonz/scriptbinding_rasterizer.h
    ../include/toonz/scriptbinding_renderer.h
    ../include/toonz/scriptbinding_scene.h
    ../include/toonz/scriptbinding_toonz_raster_converter.h
    ../include/toonz/scriptengine.h
    ../include/toonz/stylemanager.h
    ../include/toonz/tcenterlinevectorizer.h
    ../include/toonz/tcolumnhandle.h
    ../include/toonz/tframehandle.h
    ../include/toonz/tfxhandle.h
    ../include/toonz/tobjecthandle.h
    ../include/toonz/tonionskinmaskhandle.h
    ../include/toonz/tpalettehandle.h
    ../include/toonz/tscenehandle.h
    ../include/toonz/txsheethandle.h
    ../include/toonz/txshlevel.h
    ../include/toonz/txshlevelhandle.h
    ../include/toonz/txshsimplelevel.h
    ../include/toonz/txshsoundcolumn.h
)

set(HEADERS
    ${MOC_HEADERS}
    autoadjust.h
    autopos.h
    cleanupcommon.h
    cleanuppalette.h
    imagebuilders.h
    skeletonlut.h
    tcenterlinevectP.h
    texturemanager.h
    xshhandlemanager.h
    sandor_fxs/BlurMatrix.h
    sandor_fxs/CIL.h
    sandor_fxs/CallCircle.h
    sandor_fxs/CallParam.h
    sandor_fxs/EraseContour.h
    sandor_fxs/InputParam.h
    sandor_fxs/Params.h
    sandor_fxs/Pattern.h
    sandor_fxs/PatternMapParam.h
    sandor_fxs/PatternPosition.h
    sandor_fxs/SDef.h
    sandor_fxs/SDirection.h
    sandor_fxs/SError.h
    sandor_fxs/STColSelPic.h
    sandor_fxs/STPic.h
    sandor_fxs/YOMBInputParam.h
    sandor_fxs/YOMBParam.h
    sandor_fxs/blend.h
    sandor_fxs/calligraph.h
    sandor_fxs/patternmap.h
    sandor_fxs/toonz4_6staff.h
    ../include/convert2tlv.h
    ../include/orientation.h
    ../include/toonz/Naa2TlvConverter.h
    ../include/toonz/autoclose.h
    ../include/toonz/boardsettings.h
    ../include/toonz/captureparameters.h
    ../include/toonz/childstack.h
    ../include/toonz/cleanupcolorstyles.h
    ../include/toonz/cleanupparameters.h
    ../include/toonz/columnfan.h
    ../include/toonz/controlpointobserver.h
    ../include/toonz/currentimage.h
    ../include/toonz/doubleparamcmd.h
    ../include/toonz/dpiscale.h
    ../include/toonz/fill.h
    ../include/toonz/fxcommand.h
    ../include/toonz/fxdag.h
    ../include/toonz/glrasterpainter.h
    ../include/toonz/hook.h
    ../include/toonz/ikengine.h
    ../include/toonz/ikjacobian.h
    ../include/toonz/iknode.h
    ../include/toonz/ikskeleton.h
    ../include/toonz/imagelocation.h
    ../include/toonz/imagemanager.h
    ../include/toonz/imagepainter.h
    ../include/toonz/imagestyles.h
    ../include/toonz/levelproperties.h
    ../include/toonz/levelset.h
    ../include/toonz/levelupdater.h
    ../include/toonz/logger.h
    ../include/toonz/mypaint.h
    ../include/toonz/mypaintbrushstyle.h
    ../include/toonz/mypainthelpers.hpp
    ../include/toonz/namebuilder.h
    ../include/toonz/observer.h
    ../include/toonz/onionskinmask.h
    ../include/toonz/palettecmd.h
    ../include/toonz/plasticdeformerfx.h
    ../include/toonz/rasterbrush.h
    ../include/toonz/rasterstrokegenerator.h
    ../include/toonz/scenefx.h
    ../include/toonz/sceneproperties.h
    ../include/toonz/sceneresources.h
    ../include/toonz/skeleton.h
    ../include/toonz/stage.h
    ../include/toonz/stage2.h
    ../include/toonz/stageobjectutil.h
    ../include/toonz/stageplayer.h
    ../include/toonz/stagevisitor.h
    ../include/toonz/studiopalette.h
    ../include/toonz/studiopalettecmd.h
    ../include/toonz/tapplication.h
    ../include/toonz/targetcolors.h
    ../include/toonz/tbinarizer.h
    ../include/toonz/tcamera.h
    ../include/toonz/tcleanupper.h
    ../include/toonz/tcolumnfx.h
    ../include/toonz/tcolumnfxset.h
    ../include/toonz/tdistort.h
    ../include/toonz/textureutils.h
    ../include/toonz/tlog.h
    ../include/toonz/toonzfolders.h
    ../include/toonz/toonzimageutils.h
    ../include/toonz/toonzscene.h
    ../include/toonz/tpinnedrangeset.h
    ../include/toonz/tproject.h
    ../include/toonz/trasterimageutils.h
    ../include/toonz/tstageobject.h
    ../include/toonz/tstageobjectcmd.h
    ../include/toonz/tstageobjectid.h
    ../include/toonz/tstageobjectkeyframe.h
    ../include/toonz/tstageobjectspline.h
    ../include/toonz/tstageobjecttree.h
    ../include/toonz/ttilesaver.h
    ../include/toonz/ttileset.h
    ../include/toonz/tvectorimageutils.h
    ../include/toonz/txshcell.h
    ../include/toonz/txshchildlevel.h
    ../include/toonz/txshcolumn.h
    ../include/toonz/txsheet.h
    ../include/toonz/txsheetexpr.h
    ../include/toonz/txshlevelcolumn.h
    ../include/toonz/txshleveltypes.h
    ../include/toonz/txshmeshcolumn.h
    ../include/toonz/txshnoteset.h
    ../include/toonz/txshpalettecolumn.h
    ../include/toonz/txshpalettelevel.h
    ../include/toonz/txshsoundlevel.h
    ../include/toonz/txshsoundtextcolumn.h
    ../include/toonz/txshsoundtextlevel.h
    ../include/toonz/txshzeraryfxcolumn.h
    ../include/toonz/txshzeraryfxlevel.h
    ../include/toonz/vectorizerparameters.h
    ../include/toutputproperties.h
    ../include/toonz/preferencesitemids.h
    ../include/toonz/txsheetcolumnchange.h
    ../include/toonz/expressionreferencemonitor.h
    ../include/toonz/filepathproperties.h
)

set(SOURCES
    autoadjust.cpp
    autoclose.cpp
    autopos.cpp
    captureparameters.cpp
    childstack.cpp
    cleanupcolorstyles.cpp
    cleanuppalette.cpp
    cleanupparameters.cpp
    columnfan.cpp
    convert2tlv.cpp
    dpiscale.cpp
    fill.cpp
    fillutil.cpp
    fullcolorpalette.cpp
    fxdag.cpp
    glrasterpainter.cpp
    hook.cpp
    ikengine.cpp
    ikjacobian.cpp
    iknode.cpp
    ikskeleton.cpp
    imagebuilders.cpp
    imagelocation.cpp
    imagemanager.cpp
    imagepainter.cpp
    imagestyles.cpp
    levelproperties.cpp
    levelset.cpp
    levelupdater.cpp
    logger.cpp
    movierenderer.cpp
    multimediarenderer.cpp
    mypaintbrushstyle.cpp
    namebuilder.cpp
    Naa2TlvConverter.cpp
    observer.cpp
    onionskinmask.cpp
	orientation.cpp
    outputproperties.cpp
    preferences.cpp
    rasterbrush.cpp
    rasterstrokegenerator.cpp
    scenefx.cpp
    sceneproperties.cpp
    sceneresources.cpp
    scriptbinding.cpp
    scriptbinding_centerline_vectorizer.cpp
    scriptbinding_files.cpp
    scriptbinding_image.cpp
    scriptbinding_image_builder.cpp
    scriptbinding_level.cpp
    scriptbinding_outline_vectorizer.cpp
    scriptbinding_rasterizer.cpp
    scriptbinding_renderer.cpp
    scriptbinding_scene.cpp
    scriptbinding_toonz_raster_converter.cpp
    scriptengine.cpp
    skeleton.cpp
    skeletonlut.cpp
    stage.cpp
    stage2.cpp
    stageobjectutil.cpp
    stageplayer.cpp
    stagevisitor.cpp
    strokegenerator.cpp
    studiopalette.cpp
    stylemanager.cpp
    targetcolors.cpp
    tcamera.cpp
    tcenterlineadjustments.cpp
    tcenterlinecolors.cpp
    tcenterlinepolygonizer.cpp
    tcenterlineskeletonizer.cpp
    tcenterlinetostrokes.cpp
    tcenterlinevectorizer.cpp
    tcleanupper.cpp
    tcolumnfx.cpp
    tcolumnfxset.cpp
    tdistort.cpp
    texturemanager.cpp
    tlog.cpp
    tnewoutlinevectorize.cpp
    toonzfolders.cpp
    toonzimageutils.cpp
    toonzscene.cpp
    toutlinevectorizer.cpp
    tpinnedrangeset.cpp
    tproject.cpp
    trasterimageutils.cpp
    trastercentroid.cpp
    tstageobject.cpp
    tstageobjectspline.cpp
    tstageobjecttree.cpp
    ttilesaver.cpp
    ttileset.cpp
    tvectorimageutils.cpp
    txshcell.cpp
    txshchildlevel.cpp
    txshcolumn.cpp
    txsheet.cpp
    txsheetexpr.cpp
    txshlevel.cpp
    txshlevelcolumn.cpp
    txshnoteset.cpp
    txshpalettecolumn.cpp
    txshpalettelevel.cpp
    txshsimplelevel.cpp
    txshsoundcolumn.cpp
    txshsoundlevel.cpp
    txshsoundtextcolumn.cpp
    txshsoundtextlevel.cpp
    txshzeraryfxcolumn.cpp
    txshzeraryfxlevel.cpp
    xshhandlemanager.cpp
    vectorizerparameters.cpp
    sandor_fxs/blend.cpp
    sandor_fxs/BlurMatrix.cpp
    sandor_fxs/CIL.cpp
    sandor_fxs/CallCircle.cpp
    sandor_fxs/CallParam.cpp
    sandor_fxs/EraseContour.cpp
    sandor_fxs/InputParam.cpp
    sandor_fxs/Params.cpp
    sandor_fxs/Pattern.cpp
    sandor_fxs/PatternMapParam.cpp
    sandor_fxs/PatternPosition.cpp
    sandor_fxs/SDirection.cpp
    sandor_fxs/SError.cpp
    sandor_fxs/STColSelPic.cpp
    sandor_fxs/STPic.cpp
    sandor_fxs/YOMBInputParam.cpp
    sandor_fxs/YOMBParam.cpp
    sandor_fxs/calligraph.cpp
    sandor_fxs/patternmap.cpp
    sandor_fxs/toonz4_6staff.cpp
    tcolumnhandle.cpp
    tframehandle.cpp
    tfxhandle.cpp
    tobjecthandle.cpp
    tonionskinmaskhandle.cpp
    tpalettehandle.cpp
    tscenehandle.cpp
    txsheethandle.cpp
    txshlevelhandle.cpp
    doubleparamcmd.cpp
    fxcommand.cpp
    palettecmd.cpp
    palettecontroller.cpp
    studiopalettecmd.cpp
    tstageobjectcmd.cpp
    tbinarizer.cpp
    plasticdeformerfx.cpp
    txshmeshcolumn.cpp
    textureutils.cpp
    boardsettings.cpp
    filepathproperties.cpp
)

if(BUILD_TARGET_WIN)
    set(SOURCES ${SOURCES}
        avicodecrestrictions.cpp
    )
endif()

if(WITH_TRANSLATION)
    add_translation(toonzlib ${HEADERS} ${SOURCES})
endif()

qt5_wrap_cpp(SOURCES ${MOC_HEADERS})

add_library(toonzlib SHARED ${HEADERS} ${SOURCES})
if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libtoonzlib.dylib")
    add_dependencies(toonzlib tnzcore tnzbase tnzext)
endif()

add_definitions(
    -DTOONZLIB_EXPORTS
)

message("subdir: toonzlib")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

if(GLEW_FOUND)
    include_directories(${GLEW_INCLUDE_DIRS})
else()
    include_directories(${SDKROOT}/glew/glew-1.9.0/include)
endif()

include_directories(
    SYSTEM
    ${SDKROOT}/libusb/libusb-1.0.9/include
)
include_directories(
    ../toonzfarm/include
)

if(BUILD_ENV_MSVC)
    target_link_libraries(toonzlib
        Qt5::Core Qt5::Gui Qt5::OpenGL Qt5::Script Qt5::Multimedia
        ${GLUT_LIB} ${GL_LIB} ${MYPAINT_LIB_LDFLAGS} ${GLEW_LIB} vfw32.lib
        tnzcore tnzbase tnzext
    )
elseif(BUILD_ENV_APPLE)
    set(EXTRA_LIBS
        "$<TARGET_FILE:tnzcore>"
	    "$<TARGET_FILE:tnzbase>"
	    "$<TARGET_FILE:tnzext>"
        ${USB_LIB}
        ${MYPAINT_LIB_LDFLAGS}
    )

    target_link_libraries(toonzlib Qt5::Core Qt5::Gui Qt5::OpenGL Qt5::Script Qt5::Multimedia ${GLUT_LIB} ${GL_LIB} ${GLEW_LIB} ${EXTRA_LIBS})
elseif(BUILD_ENV_UNIXLIKE)
    _find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase;tnzext")

    if(BUILD_TARGET_WIN)
        set(EXTRA_LIBS ${EXTRA_LIBS} -lvfw32)
    endif()

    target_link_libraries(toonzlib Qt5::Core Qt5::Gui Qt5::OpenGL Qt5::Script Qt5::Multimedia ${GLUT_LIB} ${GL_LIB} ${GLEW_LIB} ${EXTRA_LIBS} ${MYPAINT_LIB_LDFLAGS})
endif()

=== toonz/sources/toonzqt/CMakeLists.txt ===
set(MOC_HEADERS
    palettesscanpopup.h
    pluginhost.h
    stageobjectselection.h
    tdockwindows.h
    ../include/toonzqt/addfxcontextmenu.h
    ../include/toonzqt/camerasettingswidget.h
    ../include/toonzqt/checkbox.h
    ../include/toonzqt/cleanupcamerasettingswidget.h
    ../include/toonzqt/colorfield.h
    ../include/toonzqt/combohistogram.h
    ../include/toonzqt/doublefield.h
    ../include/toonzqt/doublepairfield.h
    ../include/toonzqt/dvdialog.h
    ../include/toonzqt/dvscrollwidget.h
    ../include/toonzqt/dvtextedit.h
    ../include/toonzqt/expressionfield.h
    ../include/toonzqt/filefield.h
    ../include/toonzqt/flipconsole.h
    ../include/toonzqt/framenavigator.h
    ../include/toonzqt/functionkeyframenavigator.h
    ../include/toonzqt/functionpanel.h
    ../include/toonzqt/functionsegmentviewer.h
    ../include/toonzqt/functionselection.h
    ../include/toonzqt/functionsheet.h
    ../include/toonzqt/functiontoolbar.h
    ../include/toonzqt/functiontreeviewer.h
    ../include/toonzqt/functionviewer.h
    ../include/toonzqt/fxhistogramrender.h
    ../include/toonzqt/fxiconmanager.h
    ../include/toonzqt/fxschematicnode.h
    ../include/toonzqt/fxschematicscene.h
    ../include/toonzqt/fxselection.h
    ../include/toonzqt/fxsettings.h
    ../include/toonzqt/gutil.h
    ../include/toonzqt/hexcolornames.h
    ../include/toonzqt/histogram.h
    ../include/toonzqt/icongenerator.h
    ../include/toonzqt/imageutils.h
    ../include/toonzqt/infoviewer.h
    ../include/toonzqt/intfield.h
    ../include/toonzqt/intpairfield.h
    ../include/toonzqt/keyframenavigator.h
    ../include/toonzqt/lineedit.h
    ../include/toonzqt/marksbar.h
    ../include/toonzqt/menubarcommand.h
    ../include/toonzqt/paletteviewer.h
    ../include/toonzqt/paletteviewergui.h
    ../include/toonzqt/paramfield.h
    ../include/toonzqt/planeviewer.h
    ../include/toonzqt/popupbutton.h
    ../include/toonzqt/schematicgroupeditor.h
    ../include/toonzqt/schematicnode.h
    ../include/toonzqt/schematicviewer.h
    ../include/toonzqt/screenboard.h
    ../include/toonzqt/scriptconsole.h
    ../include/toonzqt/spectrumfield.h
    ../include/toonzqt/spreadsheetviewer.h
    ../include/toonzqt/stageschematicnode.h
    ../include/toonzqt/stageschematicscene.h
    ../include/toonzqt/studiopaletteviewer.h
    ../include/toonzqt/styleeditor.h
    ../include/toonzqt/styleindexlineedit.h
    ../include/toonzqt/stylenameeditor.h
    ../include/toonzqt/swatchviewer.h
    ../include/toonzqt/tabbar.h
    ../include/toonzqt/tmessageviewer.h
    ../include/toonzqt/tonecurvefield.h
    ../include/toonzqt/treemodel.h
    ../include/toonzqt/tselectionhandle.h
    ../include/toonzqt/updatechecker.h
    ../include/toonzqt/validatedchoicedialog.h
)

set(HEADERS
    ${MOC_HEADERS}
    ../include/tools/cursormanager.h
    docklayout.h
    functionpaneltools.h
    fxdata.h
    palettedata.h
    plugin_fxnode_interface.h
    plugin_port_interface.h
    plugin_tile_interface.h
    styledata.h
    toonz_hostif.h
    toonz_plugin.h
    ../include/historytypes.h
    ../include/toonzqt/dvmimedata.h
    ../include/toonzqt/flipconsoleowner.h
    ../include/toonzqt/freelayout.h
    ../include/toonzqt/fxtypes.h
    ../include/toonzqt/glwidget_for_highdpi.h
    ../include/toonzqt/lutcalibrator.h
    ../include/toonzqt/multipleselection.h
    ../include/toonzqt/pickrgbutils.h
    ../include/toonzqt/rasterimagedata.h
    ../include/toonzqt/selection.h
    ../include/toonzqt/selectioncommandids.h
    ../include/toonzqt/stageobjectsdata.h
    ../include/toonzqt/strokesdata.h
    ../include/toonzqt/styleselection.h
    ../include/toonzqt/trepetitionguard.h
    ../include/toonzqt/viewcommandids.h
)

set(SOURCES
    ../tnztools/cursormanager.cpp
    checkbox.cpp
    colorfield.cpp
    docklayout.cpp
    dockwidget.cpp
    doublefield.cpp
    doublepairfield.cpp
    dvdialog.cpp
    dvscrollwidget.cpp
    dvtextedit.cpp
    expressionfield.cpp
    filefield.cpp
    flipconsole.cpp
    framenavigator.cpp
    freelayout.cpp
    fxhistogramrender.cpp
    fxsettings.cpp
    gutil.cpp
    hexcolornames.cpp
    histogram.cpp
    icongenerator.cpp
    imageutils.cpp
    infoviewer.cpp
    intfield.cpp
    intpairfield.cpp
    keyframenavigator.cpp
    lineedit.cpp
    menubarcommand.cpp
    palettesscanpopup.cpp
    paletteviewer.cpp
    paletteviewergui.cpp
    paramfield.cpp
    planeviewer.cpp
    popupbutton.cpp
    rasterimagedata.cpp
    scriptconsole.cpp
    selection.cpp
    stageobjectsdata.cpp
    spectrumfield.cpp
    spreadsheetviewer.cpp
    strokesdata.cpp
    studiopaletteviewer.cpp
    styleeditor.cpp
    styleindexlineedit.cpp
    swatchviewer.cpp
    tabbar.cpp
    tdockwindows.cpp
    tonecurvefield.cpp
    treemodel.cpp
    tselectionhandle.cpp
    addfxcontextmenu.cpp
    fxschematicnode.cpp
    fxschematicscene.cpp
    schematicnode.cpp
    schematicviewer.cpp
    schematicgroupeditor.cpp
    stageschematicnode.cpp
    stageschematicscene.cpp
    functionselection.cpp
    fxselection.cpp
    stageobjectselection.cpp
    styleselection.cpp
    dvmimedata.cpp
    fxdata.cpp
    palettedata.cpp
    styledata.cpp
    functionkeyframenavigator.cpp
    functionpanel.cpp
    functionpaneltools.cpp
    functionsegmentviewer.cpp
    functionsheet.cpp
    functiontoolbar.cpp
    functiontreeviewer.cpp
    functionviewer.cpp
    updatechecker.cpp
    validatedchoicedialog.cpp
    trepetitionguard.cpp
    camerasettingswidget.cpp
    cleanupcamerasettingswidget.cpp
    pickrgbutils.cpp
    screenboard.cpp
    marksbar.cpp
    tmessageviewer.cpp
    stylenameeditor.cpp
    combohistogram.cpp
    fxiconmanager.cpp
    pluginhost.cpp
    plugin_tile_interface.cpp
    plugin_port_interface.cpp
    plugin_fxnode_interface.cpp
    plugin_param_interface.cpp
    plugin_param_view_interface.cpp
    plugin_ui_page_interface.cpp
    toonz_params.cpp
	lutcalibrator.cpp
)

set(RESOURCES toonzqt.qrc)

if(WITH_TRANSLATION)
    add_translation(toonzqt ${HEADERS} ${SOURCES})
endif()

get_target_property(QW_LOC Qt5::Widgets INTERFACE_INCLUDE_DIRECTORIES)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(incs)
foreach(dir ${Qt5Widgets_INCLUDE_DIRS})
    set(incs ${incs} -I${dir})
endforeach()

qt5_add_resources(SOURCES ${RESOURCES})

qt5_wrap_cpp(SOURCES ${MOC_HEADERS} OPTIONS ${incs})

add_library(toonzqt SHARED ${HEADERS} ${SOURCES} ${RESOURCES})
if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libtoonzqt.dylib")
    add_dependencies(toonzqt tnzcore tnzbase tnzext toonzlib sound)
endif()

add_definitions(
    -DQT_WIDGETS_LIB
    -DTOONZQT_EXPORTS
)

message("subdir: toonzqt")
message("type:" ${CMAKE_SHARED_LIBRARY_SUFFIX})
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

_find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase;tnzext;toonzlib;sound")

if(BUILD_ENV_MSVC)
    set(EXTRA_LIBS ${EXTRA_LIBS}
        advapi32.lib
    )
elseif(BUILD_ENV_UNIXLIKE)
    if(BUILD_TARGET_WIN)
        set(EXTRA_LIBS ${EXTRA_LIBS}
            -ladvapi32
        )
    endif()
endif()

target_link_libraries(toonzqt Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Network Qt5::OpenGL Qt5::Svg ${EXTRA_LIBS} ${GL_LIB})

=== debian/changelog ===
opentoonz-dmo (1.6.0-dmo0~bpo11+1) stable-backports; urgency=medium

  * Build for stable-backports

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 01 Jun 2022 21:46:52 +0200

=== debian/control ===
Source: opentoonz-dmo
Section: graphics
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://opentoonz.github.io/e/index.html
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), dh-sequence-scour, cmake, libboost-dev,
 qtbase5-dev, libqt5svg5-dev, qtscript5-dev, qttools5-dev, qttools5-dev,
 libqt5opengl5-dev, qtmultimedia5-dev, libsuperlu-dev, liblz4-dev, qtbase5-dev,
 libusb-1.0-0-dev, liblzo2-dev, libpng-dev, libjpeg-dev, freeglut3-dev, libsdl2-dev,
 libfreetype-dev, libmypaint-dev (>= 1:1.6.1~), libglew-dev (>= 2.1.0~),
 libqt5serialport5-dev, libopencv-dev, libturbojpeg0-dev, patchelf

Package: opentoonz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, opentoonz-data (= ${source:Version})
Description: full-featured 2D animation creation software
 This is software for producing a 2D animation.
 .
 It is based on the software "Toonz", which was developed by Digital Video
 S.p.A. in Italy, customized by Studio Ghibli, and has been used for
 creating its works for many years.
 Dwango launches this OpenToonz project, in cooperation with Digital Video
 and Studio Ghibli.

Package: opentoonz-data
Architecture: all
Depends: ${misc:Depends}
Description: Open-source full-featured 2D animation creation software (data package)
 This is software for producing a 2D animation.
 .
 It is based on the software "Toonz", which was developed by Digital Video
 S.p.A. in Italy, customized by Studio Ghibli, and has been used for
 creating its works for many years.
 Dwango launches this OpenToonz project, in cooperation with Digital Video
 and Studio Ghibli.
 .
 (This package contains the data files).

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(findstring parallel=,$(DEB_BUILD_OPTIONS)))
	NCPUS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
	ifeq ($(NCPUS),-1)
		NCPUS:=1
	endif
	ifeq ($(NCPUS),0)
		NCPUS:=1
	endif
endif

export DEB_CFLAGS_MAINT_APPEND = -fPIC

%:
	dh $@ -Dtoonz/sources -Bbuild -Scmake

override_dh_auto_configure:
	cd thirdparty/tiff-4.0.3 && \
	./configure --with-pic --disable-jbig

	$(MAKE) -C thirdparty/tiff-4.0.3 -j $(NCPUS)

	dh_auto_configure -- \
	-DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE -DCMAKE_SKIP_RPATH-ADVANCED:INTERNAL=FALSE

#	exit 1

# Doesn't link against system libtiff
#	-DTIFF_LIBRARY:FILEPATH=/usr/lib/$(DEB_HOST_MULTIARCH)/libtiff.so

execute_after_dh_auto_install:
	patchelf --remove-rpath debian/tmp/usr/lib/opentoonz/*.so
	patchelf --remove-rpath debian/tmp/usr/bin/t*
	patchelf --remove-rpath debian/tmp/usr/bin/l*
	patchelf --remove-rpath debian/tmp/usr/bin/OpenToonz

override_dh_auto_clean:
	[ ! -f thirdparty/tiff-4.0.3/Makefile ] || $(MAKE) -C thirdparty/tiff-4.0.3 distclean

	dh_auto_clean

override_dh_clean:

	-rm -rf thirdparty/boost
	-rm -rf thirdparty/glew
	-rm -rf thirdparty/glut
	-rm -rf thirdparty/LibJPEG
	-rm -rf thirdparty/libmypaint
	-rm -rf thirdparty/libpng-*
	-rm -rf thirdparty/libusb
	-rm -rf thirdparty/Lz4
	-rm -rf thirdparty/openblas
	-rm -rf thirdparty/quicktime
	-rm -rf thirdparty/superlu
	-rm -rf thirdparty/zlib-*

	find -name *.exe -delete

	dh_clean

# Don't delete these directories
# thirdparty/kiss_fft130
# thirdparty/lzo
# thirdparty/tiff-4.0.3

=== debian/watch ===
version=4

opts="uversionmangle=s/rc2|rc1|rc//" \
https://github.com/opentoonz/opentoonz/tags \
.*/v(.*)@ARCHIVE_EXT@
